from b2.manager import get_manager
from b2.build import generators, type as type_
from b2.tools.builtin import CScanner
from b2.util import bjam_signature


MANAGER = get_manager()
PROJECT_REGISTRY = MANAGER.projects()
ENGINE = MANAGER.engine()


type_.register('MOCK_C', [], 'C')
type_.register('MOCK_H', [], 'H')

type_.set_scanner('MOCK_C', CScanner)

generators.register_composing('mockit', ['H'], ['MOCK_C(mock_%)', 'MOCK_H(mock_%)'])


@bjam_signature([['path']])
def init(path):
    ENGINE.register_action(
        'mockit',
        """
        python {}/mockit.py $(2) $(1)
        """.format(path)
    )
